package juliac.generated;

import java.lang.annotation.Annotation;
import java.util.Collection;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.ow2.frascati.tinfi.api.IntentHandler;
import org.objectweb.fractal.api.Interface;
import org.ow2.frascati.tinfi.api.InterfaceFilter;
import org.ow2.frascati.tinfi.api.InterfaceMethodFilter;
import org.objectweb.fractal.api.control.LifeCycleController;
import java.util.List;
import java.util.Map;
import java.lang.reflect.Method;
import org.objectweb.fractal.api.control.NameController;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.ow2.frascati.tinfi.api.control.SCABasicIntentController;
import org.ow2.frascati.tinfi.api.control.SCAIntentController;
import java.util.Set;
import org.ow2.frascati.tinfi.TinfiComponentInterceptor;
import org.ow2.frascati.tinfi.TinfiRuntimeException;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin
 * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin
 */
public class SCACompositeIntentControllerImpl implements Controller , Generated , SCABasicIntentController , SCAIntentController {
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.Class,java.lang.String)
     */
    public <T extends java.lang.annotation.Annotation> void addFcIntentHandler(IntentHandler handler, Class<T>  annotcl, String value) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler ,annotcl ,value);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#weaveableOptNC
     */
    public NameController weaveableOptNC;
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler)
     */
    private void addFcIntentHandler$0(IntentHandler handler) {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = getFcInterceptors();
        for (String name : interceptors.keySet()) {
            if ((name.endsWith("-controller")) || (name.equals("component"))) {
                continue;
            } 
            TinfiComponentInterceptor<?>  tci = interceptors.get(name);
            tci.addIntentHandler(handler);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler)
     */
    public void addFcIntentHandler(IntentHandler handler) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,org.ow2.frascati.tinfi.api.InterfaceFilter)
     */
    public void addFcIntentHandler(IntentHandler handler, InterfaceFilter filter) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler ,filter);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableOptNC = ((NameController)(ic.getOptionalInterface("name-controller")));
        initFcController$1(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$2(ic);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,org.ow2.frascati.tinfi.api.InterfaceMethodFilter)
     */
    public void addFcIntentHandler(IntentHandler handler, InterfaceMethodFilter filter) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler ,filter);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,org.ow2.frascati.tinfi.api.InterfaceFilter)
     */
    private void addFcIntentHandler$0(IntentHandler handler, InterfaceFilter filter) {
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            boolean accept = filter.accept(itf);
            if (!accept) {
                continue;
            } 
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            if (!(i instanceof TinfiComponentInterceptor<?> )) {
                String name = itf.getFcItfName();
                String msg = (("Interface " + name) + " was expected to delegate to an object implementing") + " TinfiComponentInterceptor";
                throw new TinfiRuntimeException(msg);
            } 
            TinfiComponentInterceptor<?>  tci = ((TinfiComponentInterceptor<?> )(i));
            tci.addIntentHandler(handler);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.String)
     */
    public void addFcIntentHandler(IntentHandler handler, String name) throws NoSuchInterfaceException, IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler ,name);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.String,java.lang.reflect.Method)
     */
    public void addFcIntentHandler(IntentHandler handler, String name, Method method) throws NoSuchMethodException, NoSuchInterfaceException, IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler ,name ,method);
    }
    
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler)
     */
    public void removeFcIntentHandler(IntentHandler handler) throws IllegalLifeCycleException {
        checkFcStopped();
        removeFcIntentHandler$0(handler);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.String)
     */
    public void removeFcIntentHandler(IntentHandler handler, String name) throws NoSuchInterfaceException, IllegalLifeCycleException {
        checkFcStopped();
        removeFcIntentHandler$0(handler ,name);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,org.ow2.frascati.tinfi.api.InterfaceMethodFilter)
     */
    private void addFcIntentHandler$0(IntentHandler handler, InterfaceMethodFilter filter) {
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            if (!(i instanceof TinfiComponentInterceptor<?> )) {
                String name = itf.getFcItfName();
                String msg = (("Interface " + name) + " was expected to delegate to an object implementing") + " TinfiComponentInterceptor";
                throw new TinfiRuntimeException(msg);
            } 
            TinfiComponentInterceptor<?>  tci = ((TinfiComponentInterceptor<?> )(i));
            Method[] methods = tci.getMethods();
            for (Method method : methods) {
                boolean accept = filter.accept(itf ,method);
                if (accept) {
                    try {
                        tci.addIntentHandler(handler ,method);
                    } catch (NoSuchMethodException nsme) {
                        throw new TinfiRuntimeException(nsme);
                    }
                } 
            }
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.String,java.lang.reflect.Method)
     */
    public void removeFcIntentHandler(IntentHandler handler, String name, Method method) throws NoSuchMethodException, NoSuchInterfaceException, IllegalLifeCycleException {
        checkFcStopped();
        removeFcIntentHandler$0(handler ,name ,method);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#checkFcStopped()
     */
    private void checkFcStopped() throws IllegalLifeCycleException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                String msg = ("Component " + (weaveableOptNC.getFcName())) + " is not stopped";
                throw new IllegalLifeCycleException(msg);
            } 
        } 
    }
    
    private <T extends java.lang.annotation.Annotation> void addFcIntentHandler$0(IntentHandler handler, Class<T>  annotcl, String value) {
    }
    
    private void addFcIntentHandler$1(IntentHandler handler) {
    }
    
    private void addFcIntentHandler$1(IntentHandler handler, InterfaceFilter filter) {
    }
    
    private void addFcIntentHandler$1(IntentHandler handler, InterfaceMethodFilter filter) {
    }
    
    private void addFcIntentHandler$1(IntentHandler handler, String name) {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.String)
     */
    private void addFcIntentHandler$0(IntentHandler handler, String name) throws NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor<?>  tci = interceptors.get(name);
        tci.addIntentHandler(handler);
    }
    
    private void addFcIntentHandler$1(IntentHandler handler, String name, Method method) {
    }
    
    private void removeFcIntentHandler$1(IntentHandler handler) {
    }
    
    private void removeFcIntentHandler$1(IntentHandler handler, String name) {
    }
    
    private void removeFcIntentHandler$1(IntentHandler handler, String name, Method method) {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.String,java.lang.reflect.Method)
     */
    private void addFcIntentHandler$0(IntentHandler handler, String name, Method method) throws NoSuchMethodException, NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor<?>  tci = interceptors.get(name);
        tci.addIntentHandler(handler ,method);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#listFcIntentHandler(java.lang.String)
     */
    public List<org.ow2.frascati.tinfi.api.IntentHandler>  listFcIntentHandler(String name) throws NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor<?>  tci = interceptors.get(name);
        List<org.ow2.frascati.tinfi.api.IntentHandler>  handlers = tci.listIntentHandler();
        return handlers;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#listFcIntentHandler(java.lang.String,java.lang.reflect.Method)
     */
    public List<org.ow2.frascati.tinfi.api.IntentHandler>  listFcIntentHandler(String name, Method method) throws NoSuchMethodException, NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor<?>  tci = interceptors.get(name);
        List<org.ow2.frascati.tinfi.api.IntentHandler>  handlers = tci.listIntentHandler(method);
        return handlers;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler)
     */
    private void removeFcIntentHandler$0(IntentHandler handler) {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = getFcInterceptors();
        Collection<org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  tcis = interceptors.values();
        for (TinfiComponentInterceptor<?>  tci : tcis) {
            tci.removeIntentHandler(handler);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.String)
     */
    private void removeFcIntentHandler$0(IntentHandler handler, String name) throws NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor<?>  tci = interceptors.get(name);
        tci.removeIntentHandler(handler);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.api.IntentHandler,java.lang.String,java.lang.reflect.Method)
     */
    private void removeFcIntentHandler$0(IntentHandler handler, String name, Method method) throws NoSuchMethodException, NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor<?>  tci = interceptors.get(name);
        tci.removeIntentHandler(handler ,method);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#getFcInterceptors()
     */
    private Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  getFcInterceptors() {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>>  interceptors = new HashMap<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor<?>> ();
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            String name = itf.getFcItfName();
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            if (!(i instanceof TinfiComponentInterceptor<?> )) {
                String msg = (("Interface " + name) + " was expected to delegate to an object implementing") + " TinfiComponentInterceptor";
                throw new TinfiRuntimeException(msg);
            } 
            TinfiComponentInterceptor<?>  tci = ((TinfiComponentInterceptor<?> )(i));
            interceptors.put(name ,tci);
        }
        return interceptors;
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCACompositeIntentControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin org.objectweb.fractal.julia.control.name.UseNameControllerMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin)";
    }
    
}

