package juliac.generated;

import java.util.Collection;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import java.util.HashSet;
import org.ow2.frascati.tinfi.api.control.IllegalPromoterException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.Interceptor;
import java.util.List;
import java.util.Map;
import org.objectweb.fractal.api.control.NameController;
import org.ow2.frascati.tinfi.api.control.SCAPropertyController;
import java.util.Set;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin
 * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin
 * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin
 * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin
 */
public class SCACompositePropertyControllerImpl implements Controller , Generated , SCAPropertyController {
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#values
     */
    private Map<java.lang.String, java.lang.Object>  values = new HashMap<java.lang.String, java.lang.Object> ();
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#containsPropertyName(java.lang.String)
     */
    private boolean containsPropertyName$1(String name) {
        return false;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#types
     */
    private Map<java.lang.String, java.lang.Class<?>>  types = new HashMap<java.lang.String, java.lang.Class<?>> ();
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#getPropertyNames()
     */
    private String[] getPropertyNames$0() {
        return new String[0];
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#promoters
     */
    private Map<java.lang.String, org.ow2.frascati.tinfi.api.control.SCAPropertyController>  promoters = new HashMap<java.lang.String, org.ow2.frascati.tinfi.api.control.SCAPropertyController> ();
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#setType(java.lang.String,java.lang.Class)
     */
    private void setType$0(String name, Class<?>  type) {
        types.put(name ,type);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#setValue(java.lang.String,java.lang.Object)
     */
    private void setValue$0(String name, Object value) throws IllegalArgumentException {
        values.put(name ,value);
        setValue$1(name ,value);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#isDeclared(java.lang.String)
     */
    public boolean isDeclared(String name) {
        return false;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#promoterPropNames
     */
    private Map<java.lang.String, java.lang.String>  promoterPropNames = new HashMap<java.lang.String, java.lang.String> ();
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#weaveableOptNC
     */
    public NameController weaveableOptNC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#setType(java.lang.String,java.lang.Class)
     */
    public void setType(String name, Class<?>  type) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            setType$0(name ,type);
        } else {
            String promoterPropName = promoterPropNames.get(name);
            promoter.setType(promoterPropName ,type);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#getType(java.lang.String)
     */
    private Class<?>  getType$0(String name) {
        if (types.containsKey(name)) {
            Class<?>  type = types.get(name);
            return type;
        } else {
            Class<?>  type = getType$1(name);
            return type;
        }
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptNC = ((NameController)(ic.getOptionalInterface("name-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#getValue(java.lang.String)
     */
    private Object getValue$0(String name) {
        Object value = values.get(name);
        return value;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#setValue(java.lang.String,java.lang.Object)
     */
    public void setValue(String name, Object value) throws IllegalArgumentException {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            setValue$0(name ,value);
        } else {
            String promoterPropName = promoterPropNames.get(name);
            promoter.setValue(promoterPropName ,value);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#containsPropertyName(java.lang.String)
     */
    private boolean containsPropertyName$0(String name) {
        boolean b = values.containsKey(name);
        if (!b) {
            b = containsPropertyName$1(name);
        } 
        return b;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#getPropertyNames()
     */
    public String[] getPropertyNames() {
        Set<java.lang.String>  keys = new HashSet<java.lang.String> (values.keySet());
        String[] declared = getPropertyNames$0();
        keys.addAll(java.util.Arrays.asList(declared));
        String[] names = keys.toArray(new String[keys.size()]);
        return names;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#getType(java.lang.String)
     */
    public Class<?>  getType(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            Class<?>  type = getType$0(name);
            return type;
        } else {
            String promoterPropName = promoterPropNames.get(name);
            Class<?>  type = promoter.getType(promoterPropName);
            return type;
        }
    }
    
    private void initFcController$1(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#hasBeenSet(java.lang.String)
     */
    private boolean hasBeenSet$0(String name) {
        boolean b = values.containsKey(name);
        return b;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#getValue(java.lang.String)
     */
    public Object getValue(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            Object value = getValue$0(name);
            return value;
        } else {
            String promoterPropName = promoterPropNames.get(name);
            Object value = promoter.getValue(promoterPropName);
            return value;
        }
    }
    
    private String[] getPropertyNames$1() {
        return null;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#containsPropertyName(java.lang.String)
     */
    public boolean containsPropertyName(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            boolean b = containsPropertyName$0(name);
            return b;
        } else {
            String promoterPropName = promoterPropNames.get(name);
            boolean b = promoter.containsPropertyName(promoterPropName);
            return b;
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#hasBeenSet(java.lang.String)
     */
    public boolean hasBeenSet(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            boolean b = hasBeenSet$0(name);
            return b;
        } else {
            String promoterPropName = promoterPropNames.get(name);
            boolean b = promoter.hasBeenSet(promoterPropName);
            return b;
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#setPromoter(java.lang.String,org.ow2.frascati.tinfi.api.control.SCAPropertyController)
     */
    public void setPromoter(String name, SCAPropertyController promoter) throws IllegalPromoterException {
        promoters.put(name ,promoter);
        promoterPropNames.put(name ,name);
        SCAPropertyController peer = promoter.getPromoter(name);
        if (peer != null) {
            Object peerInterceptor = ((ComponentInterface)(peer)).getFcItfImpl();
            Object peerImpl = ((Interceptor)(peerInterceptor)).getFcItfDelegate();
            if (peerImpl == (this)) {
                String compname = weaveableOptNC.getFcName();
                throw new IllegalPromoterException(compname);
            } 
        } 
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#getPromoter(java.lang.String)
     */
    public SCAPropertyController getPromoter(String name) {
        return promoters.get(name);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#setPromoter(java.lang.String,org.ow2.frascati.tinfi.api.control.SCAPropertyController,java.lang.String)
     */
    public void setPromoter(String name, SCAPropertyController promoter, String promoterPropertyName) throws IllegalPromoterException {
        setPromoter(name ,promoter);
        promoterPropNames.put(name ,promoterPropertyName);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#getPromoterPropertyName(java.lang.String)
     */
    public String getPromoterPropertyName(String name) {
        return promoterPropNames.get(name);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin#removePromoter(java.lang.String)
     */
    public void removePromoter(String name) {
        promoters.remove(name);
        promoterPropNames.remove(name);
    }
    
    private void setType$1(String name, Class<?>  type) {
    }
    
    private void setValue$1(String name, Object value) throws IllegalArgumentException {
    }
    
    private Class<?>  getType$1(String name) {
        return null;
    }
    
    private Object getValue$1(String name) {
        return null;
    }
    
    private boolean containsPropertyName$2(String name) {
        return false;
    }
    
    private boolean hasBeenSet$1(String name) {
        return false;
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCACompositePropertyControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.control.name.UseNameControllerMixin org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin org.ow2.frascati.tinfi.control.property.SCAPropertyPromoterMixin)";
    }
    
}

